<?php
/**
* @Plugin: JAM - Joomla Advanced Message - A Community Builder Plugin.
* @Copyright: (c) Cas de Vroom. All rights reserved.
* @Information: See INFORATION.txt in the components directory for the license, website, etc
*/

defined( '_JEXEC') or die('Restricted access'); // no direct access

class getJAMTab extends cbPMSHandler
{
	/**
	 * Class constructor.
	 */
	function getJAMTab() {
		$this->cbPMSHandler();
	}

	/**
	 * Write a message quick
	 *
	 * @param object	$tab. Tab info
	 * @param object	$user. The object of the viewed user
	 * @param int		$ui. Frontend or backend param
	 * @acces public
	 * @return string
	 */
	function getDisplayTab($tab, $user, $ui)
	{
		// Initialize some vars
		$toid		= $user->user_id;
		$subject	= JRequest::getVar( 'subject', NULL, 'POST', 'STRING');
		$message	= JRequest::getVar( 'text', NULL, 'POST', 'STRING', JREQUEST_ALLOWRAW);
		$output		= NULL;

		// Load JAM's language
		$lang =& JFactory::getLanguage();
		$lang->load('com_jam');

		// Send a submitted message
		if ( JRequest::getVar( 'valid', false, 'POST', 'INT') )
		{
			// Send the message
			$user		=& JFactory::getUser();
			$user_id	= $user->get('id');
			$return 	.= $this->sendUserPMS( $toid, $user_id, $subject, $message, false );

			// Reinitialize some vars
			$subject	= JRequest::getVar( 'subject', NULL, 'POST', 'STRING');
			$message	= JRequest::getVar( 'text', NULL, 'POST', 'STRING', JREQUEST_ALLOWRAW);
		}

		// Build the form
		$output		.= '<form name="adminForm" action="'.JRoute::_($this->_getAbsURLwithParam(array())).'" method="post">'
					. '<table cellpadding="5" class="contentpane">'
					. 	'<tr>'
					. 		'<td align="right"><a href="'.JRoute::_($this->getPMSlink($toid, 0, 0, 0, 1)).'">'.JText::_('JAM').'</a></td>'
					. 	'</tr>'
					. 	'<tr>'
					. 		'<th>'.JText::_('Subject').'</th>'
					. 	'</tr>'
					. 	'<tr>'
					. 		'<td><input name="subject" type="text" size="40" class="inputbox"  maxlength="200" value="'.$subject.'" /><td>'
					.	 '</tr>'
					. 	'<tr>'
					. 		'<th >'.JText::_('Message').'</th>'
					. 	'</tr>'
					. 	'<tr>'
					. 		'<td><textarea name="text" cols="30" rows="12">'.$message.'</textarea></td>'
					. 	'</tr>'
					. 	'<tr>'
					. 		'<td><input type="button" name="sendbutton" onclick="this.disabled=true;submitform();return false;" value="'.JText::_( 'Send').'" /></td>'
					. 	'</tr>'
					. '</table>'
					. '<input type="hidden" name="valid" value="1" />'
					. '</form>';

		return $output;
	}

	/**
	 * Send a message
	 *
	 * @param int		$toid. The id of the receiver
	 * @param int		$fromid. The id of the sender
	 * @param string	$subject. The subject
	 * @param string	$message. The message
	 * @param boolean	$system. Is the message a system message?
	 * @acces			public
	 * @return string
	 */
	function sendUserPMS($toid, $fromid, $subject, $message, $system = false)
	{
		// Load 2 libraries
		require_once( JPATH_SITE.DS.'components'.DS.'com_jam'.DS.'classes'.DS.'messages.php');
		require_once( JPATH_SITE.DS.'components'.DS.'com_jam'.DS.'classes'.DS.'receivers.php');

		// Load JAM's language
		$lang =& JFactory::getLanguage();
		$lang->load('com_jam');

		$config		=& JAMConfig::getConfig();
		$user		=& JFactory::getUser();
		$user_id	= $fromid;
		$user_gid	= $user->get('gid');

		// Get variables
		$receivers	= array($toid);
		$datetime	= date( "Y-m-d H:i:s");
		$options	= array(
						'draft' => 0,
						'priority' => 0,
						'system' => ($system ? 1 : 0),
						'disablereply' => 0,
						'attachments' => NULL
					);

		// Remove any javascript code
		$subject	= preg_replace( '@<script[^>]*?>.*?</script>@si', ' ', $subject);
		$message	= preg_replace( '@<script[^>]*?>.*?</script>@si', ' ', $message);

		// Check if receivers have been selected, a subject and a message has been given 
		if ( ( !$receivers && (!$mass && !isset($groups[0]) && !$options['draft']) ) || !$subject || !$message )
		{
			return JText::_('Please enter (a) receiver(s), a subject and a message');
		}

		// Check if the size of the message is within the maximum size
		if ( strlen($message) > $config->get('maxmessagelength_'.$user_gid) )
		{
			return JText::sprintf( 'Your message is too long. Your message has %d characters and the limit is %d characters. Please shorten your message.', strlen($message), $config->get('maxmessagelength_'.$user_gid) );
		}

		// Make sure there are no invalid users
		if ( !JAMReceivers::ValidateUsers($receivers) )
		{
			return JText::_( 'You have selected (an) invalid receiver(s)');
		}

		// More $receivers vars
		$receivers_total	= count($receivers);
		$receivers_string	= implode( ',', $receivers );

		// Get data of the receivers
		$db			=& JFactory::getDBO();
		$select		= $config->get( 'displayname') ? 'u.name' : 'u.username';
		$query		= "SELECT u.id, u.gid, $select as user, u.email, u.params, jam.mailing, jam.mailingmessage, jam.blocked"
					. " FROM #__users AS u"
					. " LEFT JOIN #__jam_settings AS jam ON jam.userid = u.id"
					. " WHERE u.id IN ($receivers_string)";
		$db->setQuery($query);
		$receivers = $db->loadAssocList();

		/**
		* Remove some receivers (Exception: The message is a system message)
		* - If they have no space left
		* - If they have blocked the active user
		*/

		// This array contains the users who did not receive the message
		$notsent = array();

		if (!$options['system'])
		{
			// Get the amount of the messages by user
			$db->setQuery( 'SELECT COUNT(id) FROM #__jam WHERE toid = '.$receivers_string.' AND inbox != 0 GROUP BY toid');
			$amount = $db->loadResult();
			$db->setQuery( 'SELECT COUNT(id) FROM #__jam WHERE fromid = '.$receivers_string.' AND outbox != 0');
			$amount += $db->loadResult();

			foreach ($receivers as $receiver)
			{
				$id			= $receiver['id'];
				$total		= $amount;

				// Is the sender blocked by the receiver?
				if ( $config->get('blocking') )
				{
					$blocklist	= explode( ',', $receiver['blocked']);
					$blocked	= in_array( $user_id, $blocklist);
				}
				else
				{
					$blocked	= false;
				}

				// Remove the receiver from the list if necessary
				if ( $total >= $config->get('maxmessages_'.$receiver['gid']) || $blocked )
				{
					$notsent[] = $receiver['user'];
					unset($receivers[$i]);
				}
			}

			// Recreate the receivers vars as there could have been changes
			sort($receivers);
			$receivers_total	= count($receivers);
			$receivers_string	= implode( ',', array_keys($receivers) );
		}

		// Save the message(s)
		$return = NULL;
		if ($receivers)
		{
			$receivers_data = array(
							'data' => $receivers,
							'string' => $receivers_string,
							'total' => $receivers_total
						);
			$return = JAMMessages::WriteMessage($receivers_data, addslashes($subject), addslashes($message), $datetime, $options);
		}

		// Inform the user if a receiver did not receive the message
		if ($notsent)
		{
			$message	= JText::sprintf('%s has not received your message as he has no space available', $notsent[0] );
			$message	= $return->message[0].'<br />'.$message;
			return $message;
		}

		// Send the notice messages
		if ($return->noticemail)
		{
			require_once( JPATH_SITE.DS.'components'.DS.'com_jam'.DS.'classes'.DS.'email.php');

			$array = array();
			for ($i = 0, $t = count($return->noticemail); $i < $t; $i++)
			{
				$receiver	= $return->noticemail[$i];
				$params		= new JParameter($receiver['params']);

				$array[]	= array(
								'user' => $receiver['user'],
								'email' => $receiver['email'],
								'language' => $params->get('language', 'en-GB'),
								'mailingmessage' => $receiver['mailingmessage'],
								'timezone' => $params->get('timezone', '0')
							);
			}

			if (!JAMEmail::EmailAlert( $array, $subject, $datetime, $message ))
			{
				$message = $return->message[0].'<br />'.JText::_( 'The notice email(s) was / were not sent' );
				return $message;
			}
		}

		// Clean some vars
		JRequest::setVar( 'subject', $subject, 'POST');
		JRequest::setVar( 'text', $message, 'POST');

		return $return->message[0];
	}

	/**
	 * Return info about the JAM-link
	 *
	 * @param int		$toid. The user id of the receiver
	 * @param int		$fromid. The user id of the receiver
	 * @param string	$subject. Contains the subject
	 * @param string	$message. Contains the message
	 * @param int		$kind. Contains the url parameters
	 * @acces			public
	 * @return			array
	 */
	function getPMSlink($toid, $fromid, $subject, $message, $kind)
	{
		$menu	=& JSite::getMenu();
		$params	= $this->params;

		// Find the url if used by the website to JAM
		$item	= $menu->getItems( 'link', 'index.php?option=com_jam&view=inbox', true);

		// If we have an item, we use the used url, otherwise we use a standard one
		if ($item) {
			$url = 'index.php?Itemid='.$item->id;
		} else {
			$url = 'index.php?option=com_jam';
		}

		if ($kind == '1')
		{
			require_once( JPATH_SITE.DS.'components'.DS.'com_jam'.DS.'classes'.DS.'users.php');

			$caption	= $params->get('pmsMenuText', _UE_PM_USER);
			$url		= $url.'&amp;to='.JAMUsers::getUsername( $toid, ',');
			$tooltip	= $params->get('pmsMenuDesc', _UE_MENU_PM_USER_DESC);
		}
		else
		{
			$caption	= _UE_PM_INBOX;
			$tooltip	= _UE_MENU_PM_INBOX_DESC;
		}

		return array( 'caption' => $caption, 'url' => $url, 'tooltip' => $tooltip );
	}

	/**
	 * Can JAM use a subject and a message?
	 *
	 * @return array
	 */
	function getPMScapabilites()
	{
		return array( 'subject' => true, 'body' => true);
	}

	/**
	 * Get the amount of the unreaded messages
	 *
	 * @param int	$user_id. The id of the user
	 * @return int
	 */
	function getPMSunreadCount($user_id)
	{
		$db		=& JFactory::getDBO();
		$db->setQuery( 'SELECT COUNT(id) FROM #__jam WHERE toid = '.$user_id.' AND stateto = 0 AND inbox != 0;' );
		return $db->loadResult();
	}
}
?>